; L-System fractal engine
; Copyright 2005 Jari Komppa
;
; Lines starting with ; are comments
;
; Parameters
;
; Length - base length of a line
length=2
; Generation length - multiplier for the length (at opcode %)
genlength=0.3
; Number of iterations
iterations=10
; Rendering style
; 0 - Haloed/solid, full
; 1 - Haloed/solid, growing
; 2 - Transparent/additive, full
; 3 - Transparent/additive, growing
style=1
; Rotation angle, in degrees (opcodes + and -)
angle=47
; Waving angle, in degrees (0 for static)
wave=5
; Colors, three values per color (R,G,B, 0.0 - 1.0 value range)
; max. 8 color sets (opcodes 1,2,3,4,5,6,7,8, # for 'next color')
color=0,0.5,0, 0.75,0.1,0.1, 1,1,0, 0.2,0.75,0.2, 0.3,1,0.3, 0,0,0.5
;
;
; Axioms
; Any number of axioms, format X=string
; Opcodes:
; + - rotate positive 
; - - rotate negative
; . - draw forward
; : - move forward without drawing
; x,y and z - select rotation axis
; / - next rotation axis
; \ - previous rotation axis
; 1,2,3,4,5,6,7 and 8 - select color
; # - select next color
; 0 - reset position to zero
; % - multiply current length by genlength
; (a - store all parameters
; (p - store position
; (d - store direction
; (l - store length
; (x - store rotation axis
; (c - store color
; ) - restore previously stored parameter(s)
; NOTE: there must be exactly as many stores as restores!
; 
;Z=x++::(ax--xT)::(ax--xT)::(ax--xT)::(ax--xT)
;T=z++::(az--yA)::(az--yA)::(az--yA)::(az--yA)

A=/(a+4BD)(a-5BC)B
B=.1A
C=(a\2%-.++.++.++.)
D=(a\3%-.++.++.++.)

;A=/(p(d(p(d(p---B)++B)+B)B)-A)+++%
;B=(l%----.+.+A)